/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __CVAR__
#define __CVAR__

typedef struct cvar_s
{
	char		*name;
	char		*string;
	qboolean	archive;	// set to true to cause it to be saved to config.cfg
	qboolean	server;		// notifies players when changed
	int			ivalue;
	float		fvalue;
	struct cvar_s *next;
} cvar_t;

extern cvar_t	*cvar_vars;

char		*Cvar_VariableString (char *var_name);
char 		*Cvar_CompleteVariable (char *partial);
void 		Cvar_WriteVariables (FILE *f);
void 		Cvar_Set (char *var_name, char *value);
void 		Cvar_RegisterVariable (cvar_t *variable);
void		Cvar_SetValue (char *var_name, float value);
float		Cvar_VariableValue (char *var_name);
qboolean	Cvar_Command (void);

cvar_t		*Cvar_FindVar (char *var_name);

#endif //__CVAR__
