/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"
#include	"../game.h"

extern cvar_t	numbots;
extern cvar_t	numclients;

void BotInit (void)
{
	client_t	*client;
	int			i;

	//maximal number of clients and bots is 8 
	miniracer.MaxClients=numbots.ivalue+numclients.ivalue+1;
	if (miniracer.MaxClients>8)
	    miniracer.MaxClients=8;

	for (i=0, client=svs.clients; i<svs.maxclients; i++, client++)
	{
		client->edict->game.ClientNo	= -1;
		client->edict->game.Active		= false;
	}
}

void UpdateToAll (edict_t *ent)
{
	MSG_WriteByte   (&sv.reliable_datagram, svc_updatename);
	MSG_WriteByte   (&sv.reliable_datagram, ent->game.ClientNo);
	MSG_WriteString (&sv.reliable_datagram, ent->game.netname);
	MSG_WriteByte	(&sv.reliable_datagram, svc_updatecolors);
	MSG_WriteByte	(&sv.reliable_datagram, ent->game.ClientNo);
	MSG_WriteByte	(&sv.reliable_datagram, ent->game.color[0]);
	MSG_WriteByte	(&sv.reliable_datagram, ent->game.color[1]);
	MSG_WriteByte	(&sv.reliable_datagram, ent->game.color[2]);
}

void BotConnect (edict_t *ent)
{
	vec3_t	min	= {-12,-12,-4};
	vec3_t	max	= { 12, 12, 4};
	int		carmodel;

	ent->game.ClientNo		= NUM_FOR_EDICT (ent) - 1;

	ent->game.color[0]		= (MR_rand () & 51) * 5;
	ent->game.color[1]		= (MR_rand () & 51) * 5;
	ent->game.color[2]		= (MR_rand () & 51) * 5;

	ent->game.isbot 		= true;

	VectorCopy (miniracer.startpoint[ent->game.ClientNo].origin, ent->game.origin);
	VectorCopy (miniracer.startpoint[ent->game.ClientNo].angles, ent->v.angles);

	_snprintf (ent->game.netname, sizeof(ent->game.netname), "CarBot%i", ent->game.ClientNo);

	ent->game.classname		= "client";
	ent->game.bot_speed		= 600;
	ent->game.ideal_yaw		= ent->v.angles[1];
	ent->game.ways			= 0;
	ent->game.Active		= true;
	ent->game.laps			= 0;
	ent->game.laptrigger	= 3;
	ent->game.fly			= false;
	ent->game.touch			= CarTouch;

	carmodel 				= (MR_rand () & (p_numcars-1));

	Setmodel (ent, p_cars[carmodel].name);

	SetMinMaxSize	(ent, min, max);
	SV_LinkEdict	(ent, false);

	SV_BroadcastPrintf ("%s entered the game.\n", ent->game.netname);

	UpdateToAll (ent);
}

void BotDisconnect (edict_t *ent)
{
	SV_BroadcastPrintf ("%s has left the game.\n", ent->game.netname);

	_snprintf (ent->game.netname, sizeof(ent->game.netname), "");
	ent->game.color[0]		= 0;
	ent->game.color[1]		= 0;
	ent->game.color[2]		= 0;
	ent->game.classname 	= "";
	ent->game.Active		= false;
	ent->game.ClientNo 		= -1;
 	ent->game.nextthink 	= sv.time;
	ent->game.think 		= SUB_Null; 
	ent->game.isbot			= false;

	Setmodel(ent, "");

	UpdateToAll (ent);
}
