/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __GL_CAR2__
#define __GL_CAR2__

#define CAR_MAX_BODY_TRIS	1024
#define CAR_MAX_BODY_VERTS	768
#define CAR_MAX_WHEEL_TRIS	128
#define CAR_MAX_WHEEL_VERTS	64

typedef struct CAR_Triangle_s
{
	int		I[3];
	float	U[3];
	float	V[3];
} CAR_Triangle_t;

typedef struct CAR_Part_Body_s
{
	float			Origin[3];
	int				NumVertices;
	int				NumTriangles;
	float			Verts[CAR_MAX_BODY_VERTS][3];
	float			Norms[CAR_MAX_BODY_VERTS][3];
	CAR_Triangle_t	Tris[CAR_MAX_BODY_TRIS];
} CAR_Part_Body_t;

typedef struct CAR_Part_Wheel_s
{
	float			Origin[3];
	int				NumVertices;
	int				NumTriangles;
	float			Verts[CAR_MAX_WHEEL_VERTS][3];
	float			Norms[CAR_MAX_WHEEL_VERTS][3];
	CAR_Triangle_t	Tris[CAR_MAX_WHEEL_TRIS];
} CAR_Part_Wheel_t;

typedef struct CAR_Header_s 
{
	int					Version;

	CAR_Part_Body_t		Body;
	CAR_Part_Wheel_t	Wheel[4];
} CAR_Header_t;



typedef struct CAR_Part_s
{
	float			Origin[3];
	int				NumTriangles;
	float			*Coords;
	float			*Verts;
	float			*Norms;
} CAR_Part_t;

typedef struct CAR_Header2_s 
{
	CAR_Part_t	Part[5];
} CAR_Header2_t;

#endif //__GL_CAR2__
