/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __GLMINIRACER__
#define __GLMINIRACER__

// disable data conversion warnings

#ifdef _MSVC
#pragma	warning	(disable : 4244)	// MIPS
#pragma	warning	(disable : 4136)	// X86
#pragma	warning	(disable : 4051)	// ALPHA
#endif

#ifdef _WIN32
#include	<windows.h>
#endif

#include	<GL/gl.h>
#include	<GL/glu.h>

#define BACKFACE_EPSILON	0.01
#define R_CullBox(mins,maxs) (frustum[0].BoxOnPlaneSideFunc(mins, maxs, &frustum[0]) == 2 || frustum[1].BoxOnPlaneSideFunc(mins, maxs, &frustum[1]) == 2 || frustum[2].BoxOnPlaneSideFunc(mins, maxs, &frustum[2]) == 2 || frustum[3].BoxOnPlaneSideFunc(mins, maxs, &frustum[3]) == 2)

#ifdef _WIN32
typedef	void	(APIENTRY *lpMTexFUNC) (GLenum, GLfloat, GLfloat);
typedef	void	(APIENTRY *lpSelTexFUNC) (GLenum);
#endif

extern	int			r_framecount;

extern	vec3_t		vup;
extern	vec3_t		vright;
extern	vec3_t		vforward;

extern	cvar_t		gl_max_size;

extern	mleaf_t		*r_viewleaf;
extern	mleaf_t		*r_oldviewleaf;

extern	mplane_t	frustum[4];

int	 GL_LoadTexture (char *identifier, int width, int height, byte *data, qboolean mipmap, qboolean alpha);

void R_DrawSign (msurface_t *signchain);
void R_DrawWorld (void);
void R_DrawWater (msurface_t *waterchain);
void R_DrawSkyBox (void);
void GL_EndRendering (void);
void R_LightPoint (vec3_t p);
void R_DrawBrushModel (entity_t *e);

#endif //__GLMINIRACER__
